/*
 * args.h -- flag/switch definitions
 *
 * Copyright (C) 1986, 1996  Philip L. Budne
 *
 * This file is part of "Phil's Finger Program".
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 */

# define ARGS_RCSID "$Id: args.h,v 3.3 1996/06/16 03:21:04 phil Exp $"

# ifndef __EXTERN
# define __EXTERN extern
# endif /* __EXTERN not defined */

/* global (not per-person) switches */
typedef char sw_t;

__EXTERN sw_t sw_age;		/* age switch */
				/* display on rather than idle */
__EXTERN sw_t sw_berkeley;	/* be like bzerkly finger */
				/* (force -w -p with names) */
__EXTERN sw_t sw_debug;		/* enable debug output */
__EXTERN sw_t sw_follow;	/* let finger do the walking */
				/* cudos to CTorek for the idea */
__EXTERN sw_t sw_its;		/* be more like ITS (default is Twenex; */
__EXTERN sw_t sw_jobs;		/* do whoj display */
__EXTERN sw_t sw_nosave;	/* prohibit write of nlist */
				/* this is forced on by 'xf' */
__EXTERN sw_t sw_output;	/* display idle time based on last output */
__EXTERN sw_t sw_pid;		/* show current process pid */
__EXTERN sw_t sw_read;		/* force read of nlist, and save */
				/* do this from your rc file */
				/* if you don't use AUTONLIST */
__EXTERN sw_t sw_state;		/* show process state in place of idle */
__EXTERN sw_t sw_whois;		/* whois switch -- show long information */

__EXTERN char *sw_fields;	/* NYI: display output in AWKable form */

# ifdef SW_WHAT
__EXTERN sw_t sw_what;		/* what switch -- show command (BZS) */
# endif /* SW_WHAT defined */

/****************
 * flags processed per-user
 */

__EXTERN struct switches {
    int sw_location	: 1;	/* ignore user location */
    int sw_mail		: 1;	/* force mail check */
    int sw_match	: 1;	/* match on usernames only */
    int sw_noplan	: 1;	/* prhibit display of plan under /whois */
    int sw_plan		: 1;	/* check for ~/.plan file */
} Sw;

/*
 * Local variables:
 * comment-column: 32
 * End:
 */
